package com.yuandian.dataflow.proto;

import static io.grpc.MethodDescriptor.generateFullMethodName;
import static io.grpc.stub.ClientCalls.asyncBidiStreamingCall;
import static io.grpc.stub.ClientCalls.asyncClientStreamingCall;
import static io.grpc.stub.ClientCalls.asyncServerStreamingCall;
import static io.grpc.stub.ClientCalls.asyncUnaryCall;
import static io.grpc.stub.ClientCalls.blockingServerStreamingCall;
import static io.grpc.stub.ClientCalls.blockingUnaryCall;
import static io.grpc.stub.ClientCalls.futureUnaryCall;
import static io.grpc.stub.ServerCalls.asyncBidiStreamingCall;
import static io.grpc.stub.ServerCalls.asyncClientStreamingCall;
import static io.grpc.stub.ServerCalls.asyncServerStreamingCall;
import static io.grpc.stub.ServerCalls.asyncUnaryCall;
import static io.grpc.stub.ServerCalls.asyncUnimplementedStreamingCall;
import static io.grpc.stub.ServerCalls.asyncUnimplementedUnaryCall;

/**
 */
@javax.annotation.Generated(
    value = "by gRPC proto compiler (version 1.32.3)",
    comments = "Source: Processor.proto")
public final class ProcessorServerGrpc {

  private ProcessorServerGrpc() {}

  public static final String SERVICE_NAME = "com.yuandian.dataflow.proto.ProcessorServer";

  // Static method descriptors that strictly reflect the proto.
  private static volatile io.grpc.MethodDescriptor<com.yuandian.dataflow.proto.Processor.PacketsRequest,
      com.yuandian.dataflow.proto.Processor.Response> getPacketsProcessorMethod;

  @io.grpc.stub.annotations.RpcMethod(
      fullMethodName = SERVICE_NAME + '/' + "PacketsProcessor",
      requestType = com.yuandian.dataflow.proto.Processor.PacketsRequest.class,
      responseType = com.yuandian.dataflow.proto.Processor.Response.class,
      methodType = io.grpc.MethodDescriptor.MethodType.SERVER_STREAMING)
  public static io.grpc.MethodDescriptor<com.yuandian.dataflow.proto.Processor.PacketsRequest,
      com.yuandian.dataflow.proto.Processor.Response> getPacketsProcessorMethod() {
    io.grpc.MethodDescriptor<com.yuandian.dataflow.proto.Processor.PacketsRequest, com.yuandian.dataflow.proto.Processor.Response> getPacketsProcessorMethod;
    if ((getPacketsProcessorMethod = ProcessorServerGrpc.getPacketsProcessorMethod) == null) {
      synchronized (ProcessorServerGrpc.class) {
        if ((getPacketsProcessorMethod = ProcessorServerGrpc.getPacketsProcessorMethod) == null) {
          ProcessorServerGrpc.getPacketsProcessorMethod = getPacketsProcessorMethod =
              io.grpc.MethodDescriptor.<com.yuandian.dataflow.proto.Processor.PacketsRequest, com.yuandian.dataflow.proto.Processor.Response>newBuilder()
              .setType(io.grpc.MethodDescriptor.MethodType.SERVER_STREAMING)
              .setFullMethodName(generateFullMethodName(SERVICE_NAME, "PacketsProcessor"))
              .setSampledToLocalTracing(true)
              .setRequestMarshaller(io.grpc.protobuf.ProtoUtils.marshaller(
                  com.yuandian.dataflow.proto.Processor.PacketsRequest.getDefaultInstance()))
              .setResponseMarshaller(io.grpc.protobuf.ProtoUtils.marshaller(
                  com.yuandian.dataflow.proto.Processor.Response.getDefaultInstance()))
              .setSchemaDescriptor(new ProcessorServerMethodDescriptorSupplier("PacketsProcessor"))
              .build();
        }
      }
    }
    return getPacketsProcessorMethod;
  }

  /**
   * Creates a new async stub that supports all call types for the service
   */
  public static ProcessorServerStub newStub(io.grpc.Channel channel) {
    io.grpc.stub.AbstractStub.StubFactory<ProcessorServerStub> factory =
      new io.grpc.stub.AbstractStub.StubFactory<ProcessorServerStub>() {
        @java.lang.Override
        public ProcessorServerStub newStub(io.grpc.Channel channel, io.grpc.CallOptions callOptions) {
          return new ProcessorServerStub(channel, callOptions);
        }
      };
    return ProcessorServerStub.newStub(factory, channel);
  }

  /**
   * Creates a new blocking-style stub that supports unary and streaming output calls on the service
   */
  public static ProcessorServerBlockingStub newBlockingStub(
      io.grpc.Channel channel) {
    io.grpc.stub.AbstractStub.StubFactory<ProcessorServerBlockingStub> factory =
      new io.grpc.stub.AbstractStub.StubFactory<ProcessorServerBlockingStub>() {
        @java.lang.Override
        public ProcessorServerBlockingStub newStub(io.grpc.Channel channel, io.grpc.CallOptions callOptions) {
          return new ProcessorServerBlockingStub(channel, callOptions);
        }
      };
    return ProcessorServerBlockingStub.newStub(factory, channel);
  }

  /**
   * Creates a new ListenableFuture-style stub that supports unary calls on the service
   */
  public static ProcessorServerFutureStub newFutureStub(
      io.grpc.Channel channel) {
    io.grpc.stub.AbstractStub.StubFactory<ProcessorServerFutureStub> factory =
      new io.grpc.stub.AbstractStub.StubFactory<ProcessorServerFutureStub>() {
        @java.lang.Override
        public ProcessorServerFutureStub newStub(io.grpc.Channel channel, io.grpc.CallOptions callOptions) {
          return new ProcessorServerFutureStub(channel, callOptions);
        }
      };
    return ProcessorServerFutureStub.newStub(factory, channel);
  }

  /**
   */
  public static abstract class ProcessorServerImplBase implements io.grpc.BindableService {

    /**
     */
    public void packetsProcessor(com.yuandian.dataflow.proto.Processor.PacketsRequest request,
        io.grpc.stub.StreamObserver<com.yuandian.dataflow.proto.Processor.Response> responseObserver) {
      asyncUnimplementedUnaryCall(getPacketsProcessorMethod(), responseObserver);
    }

    @java.lang.Override public final io.grpc.ServerServiceDefinition bindService() {
      return io.grpc.ServerServiceDefinition.builder(getServiceDescriptor())
          .addMethod(
            getPacketsProcessorMethod(),
            asyncServerStreamingCall(
              new MethodHandlers<
                com.yuandian.dataflow.proto.Processor.PacketsRequest,
                com.yuandian.dataflow.proto.Processor.Response>(
                  this, METHODID_PACKETS_PROCESSOR)))
          .build();
    }
  }

  /**
   */
  public static final class ProcessorServerStub extends io.grpc.stub.AbstractAsyncStub<ProcessorServerStub> {
    private ProcessorServerStub(
        io.grpc.Channel channel, io.grpc.CallOptions callOptions) {
      super(channel, callOptions);
    }

    @java.lang.Override
    protected ProcessorServerStub build(
        io.grpc.Channel channel, io.grpc.CallOptions callOptions) {
      return new ProcessorServerStub(channel, callOptions);
    }

    /**
     */
    public void packetsProcessor(com.yuandian.dataflow.proto.Processor.PacketsRequest request,
        io.grpc.stub.StreamObserver<com.yuandian.dataflow.proto.Processor.Response> responseObserver) {
      asyncServerStreamingCall(
          getChannel().newCall(getPacketsProcessorMethod(), getCallOptions()), request, responseObserver);
    }
  }

  /**
   */
  public static final class ProcessorServerBlockingStub extends io.grpc.stub.AbstractBlockingStub<ProcessorServerBlockingStub> {
    private ProcessorServerBlockingStub(
        io.grpc.Channel channel, io.grpc.CallOptions callOptions) {
      super(channel, callOptions);
    }

    @java.lang.Override
    protected ProcessorServerBlockingStub build(
        io.grpc.Channel channel, io.grpc.CallOptions callOptions) {
      return new ProcessorServerBlockingStub(channel, callOptions);
    }

    /**
     */
    public java.util.Iterator<com.yuandian.dataflow.proto.Processor.Response> packetsProcessor(
        com.yuandian.dataflow.proto.Processor.PacketsRequest request) {
      return blockingServerStreamingCall(
          getChannel(), getPacketsProcessorMethod(), getCallOptions(), request);
    }
  }

  /**
   */
  public static final class ProcessorServerFutureStub extends io.grpc.stub.AbstractFutureStub<ProcessorServerFutureStub> {
    private ProcessorServerFutureStub(
        io.grpc.Channel channel, io.grpc.CallOptions callOptions) {
      super(channel, callOptions);
    }

    @java.lang.Override
    protected ProcessorServerFutureStub build(
        io.grpc.Channel channel, io.grpc.CallOptions callOptions) {
      return new ProcessorServerFutureStub(channel, callOptions);
    }
  }

  private static final int METHODID_PACKETS_PROCESSOR = 0;

  private static final class MethodHandlers<Req, Resp> implements
      io.grpc.stub.ServerCalls.UnaryMethod<Req, Resp>,
      io.grpc.stub.ServerCalls.ServerStreamingMethod<Req, Resp>,
      io.grpc.stub.ServerCalls.ClientStreamingMethod<Req, Resp>,
      io.grpc.stub.ServerCalls.BidiStreamingMethod<Req, Resp> {
    private final ProcessorServerImplBase serviceImpl;
    private final int methodId;

    MethodHandlers(ProcessorServerImplBase serviceImpl, int methodId) {
      this.serviceImpl = serviceImpl;
      this.methodId = methodId;
    }

    @java.lang.Override
    @java.lang.SuppressWarnings("unchecked")
    public void invoke(Req request, io.grpc.stub.StreamObserver<Resp> responseObserver) {
      switch (methodId) {
        case METHODID_PACKETS_PROCESSOR:
          serviceImpl.packetsProcessor((com.yuandian.dataflow.proto.Processor.PacketsRequest) request,
              (io.grpc.stub.StreamObserver<com.yuandian.dataflow.proto.Processor.Response>) responseObserver);
          break;
        default:
          throw new AssertionError();
      }
    }

    @java.lang.Override
    @java.lang.SuppressWarnings("unchecked")
    public io.grpc.stub.StreamObserver<Req> invoke(
        io.grpc.stub.StreamObserver<Resp> responseObserver) {
      switch (methodId) {
        default:
          throw new AssertionError();
      }
    }
  }

  private static abstract class ProcessorServerBaseDescriptorSupplier
      implements io.grpc.protobuf.ProtoFileDescriptorSupplier, io.grpc.protobuf.ProtoServiceDescriptorSupplier {
    ProcessorServerBaseDescriptorSupplier() {}

    @java.lang.Override
    public com.google.protobuf.Descriptors.FileDescriptor getFileDescriptor() {
      return com.yuandian.dataflow.proto.Processor.getDescriptor();
    }

    @java.lang.Override
    public com.google.protobuf.Descriptors.ServiceDescriptor getServiceDescriptor() {
      return getFileDescriptor().findServiceByName("ProcessorServer");
    }
  }

  private static final class ProcessorServerFileDescriptorSupplier
      extends ProcessorServerBaseDescriptorSupplier {
    ProcessorServerFileDescriptorSupplier() {}
  }

  private static final class ProcessorServerMethodDescriptorSupplier
      extends ProcessorServerBaseDescriptorSupplier
      implements io.grpc.protobuf.ProtoMethodDescriptorSupplier {
    private final String methodName;

    ProcessorServerMethodDescriptorSupplier(String methodName) {
      this.methodName = methodName;
    }

    @java.lang.Override
    public com.google.protobuf.Descriptors.MethodDescriptor getMethodDescriptor() {
      return getServiceDescriptor().findMethodByName(methodName);
    }
  }

  private static volatile io.grpc.ServiceDescriptor serviceDescriptor;

  public static io.grpc.ServiceDescriptor getServiceDescriptor() {
    io.grpc.ServiceDescriptor result = serviceDescriptor;
    if (result == null) {
      synchronized (ProcessorServerGrpc.class) {
        result = serviceDescriptor;
        if (result == null) {
          serviceDescriptor = result = io.grpc.ServiceDescriptor.newBuilder(SERVICE_NAME)
              .setSchemaDescriptor(new ProcessorServerFileDescriptorSupplier())
              .addMethod(getPacketsProcessorMethod())
              .build();
        }
      }
    }
    return result;
  }
}
